#<Code pour vérifier qu'aucun indicateur de compromission ne soit sur le système>

#Le code vérifie qu'il n'y a pas de tâches planifiées portant le nom de la variable $taskName
function CheckScheduledTasks($taskName) {

    $taskExists = Get-ScheduledTask | Where-Object {$_.TaskName -like $taskName }

    if($taskExists) {
       Write-Output "Presence of the task "+$name
    }
}

#Le code vérifie qu'il n'y a pas de fichier portant le hash présent dans la variable $hash
#La variable $path indique depuis quel dossier racine le hash doit être recherché
function CheckHashFile($hash,$path){
    
    Get-ChildItem -Path $path -Recurse | ForEach-Object {
        $absolute_path = Join-Path -Path $_.Directory -ChildPath $_.Name
        $hashfile= Get-FileHash $absolute_path -Algorithm SHA256
        $hashfile=$hashfile.hash
        if($hashfile -eq $hash){
            Write-Output "Presence of the hash "+$hash
        }
    }
}

#Le code vérifie qu'il n'y a pas de fichier portant le nom présent dans la variable $name
#La variable $path indique depuis quel dossier racine le nom de fichier doit être recherché
function CheckNameFile($absolute_path_name,$name,$path){
    Get-ChildItem -Path $path -Recurse | ForEach-Object {
        $absolute_path = Join-Path -Path $_.Directory -ChildPath $_.Name
        if($absolute_path_name -eq $absolute_path){
            Write-Output "Presence of the file "+$absolute_path_name
        }
 
        if($_.Name -eq $name){
            Write-Output "Presence of the file "+$name
        }
    }
}